Bug 15441 - NFS locking does not invoke the filesystem lock operation
Summary: NFS locking does not invoke the filesystem lock operation
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
(Show other bugs)
Version: 8.0
Hardware: i386 Linux
high
high
Target Milestone: ---
Assignee: Arjan van de Ven
QA Contact: Brian Brock
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2000-08-04 20:16 UTC by Brian P. Dixon
Modified: 2008-08-01 16:22 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-30 15:38:48 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

Description Brian P. Dixon 2000-08-04 20:16:32 UTC
NFS locking routines (nlmsvc_lock and others in svclock.c) go directly
to the default kernel operations (eg., posix_lock_file) and do not invoke
any filesystem lock operation that may have been provided.  They SHOULD
invoke the lock file_operation (if one exists for the filesystem)
similarly to the non-NFS fcntl_setlk which does the following:
  
   if (filp->f_op->lock != NULL) {
       error = filp->f_op->lock(filp, cmd, &file_lock); 
  
Without this, a filesystem that needs to provide the lock operation has no
way to achieve proper locking via nfs clients.

Comment 1 Cristian Gafton 2000-08-09 02:35:30 UTC
assigned to johnsonm

Comment 2 Michael K. Johnson 2000-08-31 22:05:35 UTC
Alan, you wanted lots of testing on this one; how can we get this?


Comment 3 Mike Vaillancourt 2001-02-16 23:53:41 UTC
Has there been any update on this bug?

Comment 4 Alan Cox 2001-02-21 21:35:48 UTC
I am happy that this is a real bug. No existing code Red Hat ship is effected by
it but a hypothetical
third party file system (I suspect a not so hypothetical AFS too) would be
affected by this and it
is a reasonable change.

I thought IBM provided 2.4.x patches for this. If they have a 2.4 set for that
bug can they send me a copy and I'll add it to  the 2.4ac base 


Comment 5 Yil-Kyu Kang 2001-02-27 15:56:47 UTC
Can I please be updated on the latest for this bug? I was informed that IBM sent
you this patch on 2/23/01. Will this be resolved in our next release? Thanks,
Kyu

Comment 6 Alan Cox 2001-02-27 16:02:06 UTC
Its in the current -ac tree for testing. I had to fix some formatting mess and
bits they didnt do but
it seems ok. For Linus tree IBM should discuss the -ac changes with Matthew
Wilcox
<matthew@wil.cx> who is the locking maintainer. He is aware of the changes

Alan


Comment 7 Yil-Kyu Kang 2001-03-09 17:53:53 UTC
Thank you for the update Alan. Will patch be a part of our next release?

Comment 8 Michael K. Johnson 2001-03-13 04:22:28 UTC
Kyu, please send linux-2.4.2-lockd.patch to IBM so they can look at
it.

Comment 9 Yil-Kyu Kang 2001-03-20 13:40:22 UTC
I have sent and IBM reviewed the lockd.patch. They informed me that  everything
looks great.

Comment 10 Arjan van de Ven 2001-03-20 13:49:09 UTC
Great! I will close this bug now as fixed, if something comes up, feel free
to reopen it again.

Comment 11 IBM Bug Proxy 2001-11-02 17:32:46 UTC
This patch (svclock.c) apparently did not make it into a Linus kernel.org
release although it was accepted into 2.2.4-ac23 - why did this happen?

Comment 12 Alan Cox 2001-11-02 17:42:28 UTC
I assume because Linus didn't decide to adopt it. You want to discuss that with
Linus.


Comment 13 IBM Bug Proxy 2001-11-07 22:01:49 UTC
Before we discuss this with Linus, is there any indication as to why it
was not accepted.

Comment 14 Alan Cox 2001-11-08 11:57:04 UTC
I dont have any, its been a long time


Comment 15 Arjan van de Ven 2001-11-13 16:06:10 UTC
Is this the hooks for IBM's binary only filesystem ?

Comment 16 Alan Cox 2001-11-13 16:54:23 UTC
Well it matters for AFS (which is now not binary only anyway) but its also a
genuine 100% kosher bug.


Comment 17 IBM Bug Proxy 2002-01-08 19:46:11 UTC
What would be the most expeditious approach get this patch accepted into
the Linus kernel?

Comment 18 Arjan van de Ven 2002-01-08 19:47:56 UTC
How about sending it to Linus and Marcelo with explenation ?

Comment 19 Bugzilla owner 2004-09-30 15:38:48 UTC
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem
persists.

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/



Note You need to log in before you can comment on or make changes to this bug.